/***********************************************************************/
/*                                                                     */
/*  FILE        :iodefine.h                                            */
/*  DATE        :Mon, Aug 18, 2014                                     */
/*  DESCRIPTION :Definition of I/O Register                            */
/*  CPU TYPE    :H8S/2144                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/
                  



/************************************************************************/
/*      H8S/2144 Series Include File                       Ver 2.0      */
/************************************************************************/
union un_kbcomp {                                       /* union KBCOMP */
                unsigned char BYTE;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       unsigned char IrE  :1;           /*    IrE       */
                       unsigned char IrCKS:3;           /*    IrCKS     */
                       unsigned char KBADE:1;           /*    KBADE     */
                       unsigned char KBCH :3;           /*    KBCH      */
                       }      BIT;                      /*              */
};                                                      /*              */
struct st_intc {                                        /* struct INTC  */
               union {                                  /* ICRA         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char _IRQ0 :1;     /*    IRQ0      */
                            unsigned char _IRQ1 :1;     /*    IRQ1      */
                            unsigned char _IRQ23:1;     /*    IRQ2,IRQ3 */
                            unsigned char _IRQ45:1;     /*    IRQ4,IRQ5 */
                            unsigned char _IRQ67:1;     /*    IRQ6,IRQ7 */
                            unsigned char       :1;     /*              */
                            unsigned char _WDT0 :1;     /*    WDT0      */
                            unsigned char _WDT1 :1;     /*    WDT1      */
                            }      BIT;                 /*              */
                     }          ICRA;                   /*              */
               union {                                  /* ICRB         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char _AD  :1;      /*    A/D       */
                            unsigned char _FRT :1;      /*    FRT       */
                            unsigned char      :2;      /*              */
                            unsigned char _TMR0:1;      /*    TMR0      */
                            unsigned char _TMR1:1;      /*    TMR1      */
                            unsigned char _TMRY:1;      /*    TMRY      */
                            }      BIT;                 /*              */
                     }          ICRB;                   /*              */
               union {                                  /* ICRC         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char _SCI0:1;      /*    SCI0      */
                            unsigned char _SCI1:1;      /*    SCI1      */
                            unsigned char _SCI2:1;      /*    SCI2      */
                            }      BIT;                 /*              */
                     }          ICRC;                   /*              */
               union {                                  /* ISR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char IRQ7F:1;      /*    IRQ7F     */
                            unsigned char IRQ6F:1;      /*    IRQ6F     */
                            unsigned char IRQ5F:1;      /*    IRQ5F     */
                            unsigned char IRQ4F:1;      /*    IRQ4F     */
                            unsigned char IRQ3F:1;      /*    IRQ3F     */
                            unsigned char IRQ2F:1;      /*    IRQ2F     */
                            unsigned char IRQ1F:1;      /*    IRQ1F     */
                            unsigned char IRQ0F:1;      /*    IRQ0F     */
                            }      BIT;                 /*              */
                     }          ISR;                    /*              */
               union {                                  /* ISCR         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    ISCRH     */
                            unsigned char L;            /*    ISCRL     */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char IRQ7SC:2;     /*    IRQ7SC    */
                            unsigned char IRQ6SC:2;     /*    IRQ6SC    */
                            unsigned char IRQ5SC:2;     /*    IRQ5SC    */
                            unsigned char IRQ4SC:2;     /*    IRQ4SC    */
                            unsigned char IRQ3SC:2;     /*    IRQ3SC    */
                            unsigned char IRQ2SC:2;     /*    IRQ2SC    */
                            unsigned char IRQ1SC:2;     /*    IRQ1SC    */
                            unsigned char IRQ0SC:2;     /*    IRQ0SC    */
                            }     BIT;                  /*              */
                     }          ISCR;                   /*              */
               char             wk1[6];                 /*              */
               union {                                  /* ABRKCR       */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMF:1;        /*    CMF       */
                            unsigned char    :6;        /*              */
                            unsigned char BIE:1;        /*    BIE       */
                            }      BIT;                 /*              */
                     }          ABRKCR;                 /*              */
               unsigned char    BARA;                   /* BARA         */
               unsigned char    BARB;                   /* BARB         */
               unsigned char    BARC;                   /* BARC         */
               char             wk2[202];               /*              */
               union {                                  /* IER          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char IRQ7E:1;      /*    IRQ7E     */
                            unsigned char IRQ6E:1;      /*    IRQ6E     */
                            unsigned char IRQ5E:1;      /*    IRQ5E     */
                            unsigned char IRQ4E:1;      /*    IRQ4E     */
                            unsigned char IRQ3E:1;      /*    IRQ3E     */
                            unsigned char IRQ2E:1;      /*    IRQ2E     */
                            unsigned char IRQ1E:1;      /*    IRQ1E     */
                            unsigned char IRQ0E:1;      /*    IRQ0E     */
                            }      BIT;                 /*              */
                     }          IER;                    /*              */
               char             wk3[46];                /*              */
               union {                                  /* KMIMR        */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char B7:1;         /*    Bit 7     */
                            unsigned char B6:1;         /*    Bit 6     */
                            unsigned char B5:1;         /*    Bit 5     */
                            unsigned char B4:1;         /*    Bit 4     */
                            unsigned char B3:1;         /*    Bit 3     */
                            unsigned char B2:1;         /*    Bit 2     */
                            unsigned char B1:1;         /*    Bit 1     */
                            unsigned char B0:1;         /*    Bit 0     */
                            }      BIT;                 /*              */
                     }          KMIMR;                  /*              */
               char             wk4;                    /*              */
               union {                                  /* KMIMRA       */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char B15:1;        /*    Bit 7     */
                            unsigned char B14:1;        /*    Bit 6     */
                            unsigned char B13:1;        /*    Bit 5     */
                            unsigned char B12:1;        /*    Bit 4     */
                            unsigned char B11:1;        /*    Bit 3     */
                            unsigned char B10:1;        /*    Bit 2     */
                            unsigned char B9 :1;        /*    Bit 1     */
                            unsigned char B8 :1;        /*    Bit 0     */
                            }      BIT;                 /*              */
                     }          KMIMRA;                 /*              */
};                                                      /*              */
struct st_flash {                                       /* struct FLASH */
                union {                                 /* FLMCR1       */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FWE:1;       /*    FWE       */
                             unsigned char SWE:1;       /*    SWE       */
                             unsigned char    :2;       /*              */
                             unsigned char EV :1;       /*    EV        */
                             unsigned char PV :1;       /*    PV        */
                             unsigned char E  :1;       /*    E         */
                             unsigned char P  :1;       /*    P         */
                             }      BIT;                /*              */
                      }         FLMCR1;                 /*              */
                union {                                 /* FLMCR2       */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FLER:1;      /*    FLER      */
                             unsigned char     :5;      /*              */
                             unsigned char ESU :1;      /*    ESU       */
                             unsigned char PSU :1;      /*    PSU       */
                             }      BIT;                /*              */
                      }         FLMCR2;                 /*              */
                union {                                 /* EBR1         */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char    :6;       /*              */
                             unsigned char EB9:1;       /*    EB9       */
                             unsigned char EB8:1;       /*    EB8       */
                             }      BIT;                /*              */
                      }         EBR1;                   /*              */
                union {                                 /* EBR2         */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char EB7:1;       /*    EB7       */
                             unsigned char EB6:1;       /*    EB6       */
                             unsigned char EB5:1;       /*    EB5       */
                             unsigned char EB4:1;       /*    EB4       */
                             unsigned char EB3:1;       /*    EB3       */
                             unsigned char EB2:1;       /*    EB2       */
                             unsigned char EB1:1;       /*    EB1       */
                             unsigned char EB0:1;       /*    EB0       */
                             }      BIT;                /*              */
                      }         EBR2;                   /*              */
};                                                      /*              */
union un_sbycr {                                        /* union SBYCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char SSBY:1;             /*    SSBY      */
                      unsigned char STS :3;             /*    STS       */
                      unsigned char     :1;             /*              */
                      unsigned char SCK :3;             /*    SCK       */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_lpwrcr {                                       /* union LPWRCR */
                unsigned char BYTE;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       unsigned char DTON :1;           /*    DTON      */
                       unsigned char LSON :1;           /*    LSON      */
                       unsigned char NESEL:1;           /*    NESEL     */
                       unsigned char EXCLE:1;           /*    EXCLE     */
                       }      BIT;                      /*              */
};                                                      /*              */
union un_mstpcr {                                       /* union MSTPCR */
                unsigned int WORD;                      /*  Word Access */
                struct {                                /*  Byte Access */
                       unsigned char H;                 /*    MSTPCRH   */
                       unsigned char L;                 /*    MSTPCRL   */
                       }     BYTE;                      /*              */
                struct {                                /*  Bit  Access */
                       unsigned char       :2;          /*              */
                       unsigned char _FRT  :1;          /*    FRT       */
                       unsigned char _TMR01:1;          /*    TMR0,TMR1 */
                       unsigned char _PWMX :1;          /*    PWMX      */
                       unsigned char _DA   :1;          /*    D/A       */
                       unsigned char _AD   :1;          /*    A/D       */
                       unsigned char _TMRY :1;          /*    TMRY      */
                       unsigned char _SCI0 :1;          /*    SCI0      */
                       unsigned char _SCI1 :1;          /*    SCI1      */
                       unsigned char _SCI2 :1;          /*    SCI2      */
                       }     BIT;                       /*              */
};                                                      /*              */
union un_stcr {                                         /* union STCR   */
              unsigned char BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char IICS :1;             /*    IICS      */
                     unsigned char IICX1:1;             /*    IICX1     */
                     unsigned char IICX0:1;             /*    IICX0     */
                     unsigned char IICE :1;             /*    IICE      */
                     unsigned char FLSHE:1;             /*    FLSHE     */
                     unsigned char      :1;             /*              */
                     unsigned char ICKS1:1;             /*    ICKS1     */
                     unsigned char ICKS0:1;             /*    ICKS0     */
                     }      BIT;                        /*              */
};                                                      /*              */
union un_syscr {                                        /* union SYSCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char CS2E :1;            /*    CS2E      */
                      unsigned char IOSE :1;            /*    IOSE      */
                      unsigned char INTM :2;            /*    INTM      */
                      unsigned char XRST :1;            /*    XRST      */
                      unsigned char NMIEG:1;            /*    NMIEG     */
                      unsigned char HIE  :1;            /*    HIE       */
                      unsigned char RAME :1;            /*    RAME      */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_mdcr {                                         /* union MDCR   */
              unsigned char BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char EXPE:1;              /*    EXPE      */
                     unsigned char     :5;              /*              */
                     unsigned char MDS :2;              /*    MDS       */
                     }      BIT;                        /*              */
};                                                      /*              */
struct st_sci {                                         /* struct SCI   */
              union {                                   /* SMR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CA  :1;        /*    C/A       */
                           unsigned char CHR :1;        /*    CHR       */
                           unsigned char PE  :1;        /*    PE        */
                           unsigned char OE  :1;        /*    O/E       */
                           unsigned char STOP:1;        /*    STOP      */
                           unsigned char MP  :1;        /*    MP        */
                           unsigned char CKS :2;        /*    CKS       */
                           }      BIT;                  /*              */
                    }           SMR;                    /*              */
              unsigned char     BRR;                    /* BRR          */
              union {                                   /* SCR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TIE :1;        /*    TIE       */
                           unsigned char RIE :1;        /*    RIE       */
                           unsigned char TE  :1;        /*    TE        */
                           unsigned char RE  :1;        /*    RE        */
                           unsigned char MPIE:1;        /*    MPIE      */
                           unsigned char TEIE:1;        /*    TEIE      */
                           unsigned char CKE :2;        /*    CKE       */
                           }      BIT;                  /*              */
                    }           SCR;                    /*              */
              unsigned char     TDR;                    /* TDR          */
              union {                                   /* SSR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TDRE:1;        /*    TDRE      */
                           unsigned char RDRF:1;        /*    RDRF      */
                           unsigned char ORER:1;        /*    ORER      */
                           unsigned char FER :1;        /*    FER       */
                           unsigned char PER :1;        /*    PER       */
                           unsigned char TEND:1;        /*    TEND      */
                           unsigned char MPB :1;        /*    MPB       */
                           unsigned char MPBT:1;        /*    MPBT      */
                           }      BIT;                  /*              */
                    }           SSR;                    /*              */
              unsigned char     RDR;                    /* RDR          */
              union {                                   /* SCMR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char     :4;        /*              */
                           unsigned char SDIR:1;        /*    SDIR      */
                           unsigned char SINV:1;        /*    SINV      */
                           unsigned char     :1;        /*              */
                           unsigned char SMIF:1;        /*    SMIF      */
                           }      BIT;                  /*              */
                    }           SCMR;                   /*              */
};                                                      /*              */
struct st_frt {                                         /* struct FRT   */
              union {                                   /* TIER         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ICIAE:1;       /*    ICIAE     */
                           unsigned char ICIBE:1;       /*    ICIBE     */
                           unsigned char ICICE:1;       /*    ICICE     */
                           unsigned char ICIDE:1;       /*    ICIDE     */
                           unsigned char OCIAE:1;       /*    OCIAE     */
                           unsigned char OCIBE:1;       /*    OCIBE     */
                           unsigned char OVIE :1;       /*    OVIE      */
                           }      BIT;                  /*              */
                    }           TIER;                   /*              */
              union {                                   /* TCSR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ICFA :1;       /*    ICFA      */
                           unsigned char ICFB :1;       /*    ICFB      */
                           unsigned char ICFC :1;       /*    ICFC      */
                           unsigned char ICFD :1;       /*    ICFD      */
                           unsigned char OCFA :1;       /*    OCFA      */
                           unsigned char OCFB :1;       /*    OCFB      */
                           unsigned char OVF  :1;       /*    OVF       */
                           unsigned char CCLRA:1;       /*    CCLRA     */
                           }      BIT;                  /*              */
                    }           TCSR;                   /*              */
              unsigned int      FRC;                    /* FRC          */
              unsigned int      OCRA;                   /* OCRA or OCRB */
              union {                                   /* TCR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char IEDGA:1;       /*    IEDGA     */
                           unsigned char IEDGB:1;       /*    IEDGB     */
                           unsigned char IEDGC:1;       /*    IEDGC     */
                           unsigned char IEDGD:1;       /*    IEDGD     */
                           unsigned char BUFEA:1;       /*    BUFEA     */
                           unsigned char BUFEB:1;       /*    BUFEB     */
                           unsigned char CKS  :2;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR;                    /*              */
              union {                                   /* TOCR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ICRDMS:1;      /*    ICRDMS    */
                           unsigned char OCRAMS:1;      /*    OCRAMS    */
                           unsigned char ICRS  :1;      /*    ICRS      */
                           unsigned char OCRS  :1;      /*    OCRS      */
                           unsigned char OEA   :1;      /*    OEA       */
                           unsigned char OEB   :1;      /*    OEB       */
                           unsigned char OLVLA :1;      /*    OLVLA     */
                           unsigned char OLVLB :1;      /*    OLVLB     */
                           }      BIT;                  /*              */
                    }           TOCR;                   /*              */
              unsigned int      ICRA;                   /* ICRA or OCRAR*/
              unsigned int      ICRB;                   /* ICRB or OCRAF*/
              unsigned int      ICRC;                   /* ICRC or OCRDM*/
              unsigned int      ICRD;                   /* ICRD         */
};                                                      /*              */
union un_pwmx {                                         /* struct PWMX  */
              struct {                                  /*              */
                     union {                            /* DACR         */
                           unsigned char BYTE;          /*  Byte Access */
                           struct {                     /*  Bit  Access */
                                  unsigned char TEST:1; /*    TEST      */
                                  unsigned char PWME:1; /*    PWME      */
                                  unsigned char     :2; /*              */
                                  unsigned char OEB :1; /*    OEB       */
                                  unsigned char OEA :1; /*    OEA       */
                                  unsigned char OS  :1; /*    OS        */
                                  unsigned char CKS :1; /*    CKS       */
                                  }      BIT;           /*              */
                           } ST_DACR;                   /*              */
                     char    wk[5];                     /*              */
                     union {                            /* DACNT        */
                           unsigned int WORD;           /*  Word Access */
                           struct {                     /*  Bit  Access */
                                  unsigned int     :15; /*              */
                                  unsigned int REGS: 1; /*    REGS      */
                                  }     BIT;            /*              */
                           } ST_DACNT;                  /*              */
                     } REGS1;                           /*              */
              struct {                                  /*              */
                     union {                            /* DADRA        */
                           unsigned int WORD;           /*  Word Access */
                           struct {                     /*  Bit  Access */
                                  unsigned int    :14;  /*              */
                                  unsigned int CFS: 1;  /*    CFS       */
                                  }      BIT;           /*              */
                           } ST_DADRA;                  /*              */
                     char    wk[4];                     /*              */
                     union {                            /* DADRB        */
                           unsigned int WORD;           /*  Word Access */
                           struct {                     /*  Bit  Access */
                                  unsigned int     :14; /*              */
                                  unsigned int CFS : 1; /*    CFS       */
                                  unsigned int REGS: 1; /*    REGS      */
                                  }     BIT;            /*              */
                           } ST_DADRB;                  /*              */
                     } REGS0;                           /*              */
};                                                      /*              */
union un_wdt0 {                                         /* union WDT0   */
             struct {                                   /* Read  Access */
                    union {                             /* TCSR         */
                          unsigned char BYTE;           /*  Byte Access */
                          struct {                      /*  Bit  Access */
                                 unsigned char OVF   :1;/*    OVF       */
                                 unsigned char WTIT  :1;/*    WT/IT     */
                                 unsigned char TME   :1;/*    TME       */
                                 unsigned char RSTS  :1;/*    RSTS      */
                                 unsigned char RSTNMI:1;/*    RST/NMI   */
                                 unsigned char CKS   :3;/*    CKS       */
                                 }      BIT;            /*              */
                          }       TCSR;                 /*              */
                    unsigned char TCNT;                 /* TCNT         */
                    } READ;                             /*              */
             union  {                                   /* Write Access */
                    unsigned int  TCSR;                 /* TCSR         */
                    unsigned int  TCNT;                 /* TCNT         */
                    } WRITE;                            /*              */
};                                                      /*              */
union un_wdt1 {                                         /* union WDT1   */
             struct {                                   /* Read  Access */
                    union {                             /* TCSR         */
                          unsigned char BYTE;           /*  Byte Access */
                          struct {                      /*  Bit  Access */
                                 unsigned char OVF   :1;/*    OVF       */
                                 unsigned char WTIT  :1;/*    WT/IT     */
                                 unsigned char TME   :1;/*    TME       */
                                 unsigned char PSS   :1;/*    PSS       */
                                 unsigned char RSTNMI:1;/*    RST/NMI   */
                                 unsigned char CKS   :3;/*    CKS       */
                                 }      BIT;            /*              */
                          }       TCSR;                 /*              */
                    unsigned char TCNT;                 /* TCNT         */
                    } READ;                             /*              */
             union  {                                   /* Write Access */
                    unsigned int  TCSR;                 /* TCSR         */
                    unsigned int  TCNT;                 /* TCNT         */
                    } WRITE;                            /*              */
};                                                      /*              */
struct st_p1 {                                          /* struct P1    */
             union {                                    /* P1PCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk1[3];                 /*              */
             unsigned char      DDR;                    /* P1DDR        */
             char               wk2;                    /*              */
             union {                                    /* P1DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p2 {                                          /* struct P2    */
             union {                                    /* P2PCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk1[3];                 /*              */
             unsigned char      DDR;                    /* P2DDR        */
             char               wk2;                    /*              */
             union {                                    /* P2DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p3 {                                          /* struct P3    */
             union {                                    /* P3PCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk1[5];                 /*              */
             unsigned char      DDR;                    /* P3DDR        */
             char               wk2;                    /*              */
             union {                                    /* P3DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p4 {                                          /* struct P4    */
             unsigned char      DDR;                    /* P4DDR        */
             char               wk;                     /*              */
             union {                                    /* P4DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p5 {                                          /* struct P5    */
             unsigned char      DDR;                    /* P5DDR        */
             char               wk;                     /*              */
             union {                                    /* P5DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :5;           /*    Bit 7-3   */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p6 {                                          /* struct P6    */
             unsigned char      DDR;                    /* P6DDR        */
             char               wk1;                    /*              */
             union {                                    /* P6DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk2[54];                /*              */
             union {                                    /* P6PCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
};                                                      /*              */
struct st_p7 {                                          /* struct P7    */
             union {                                    /* P7PIN        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PIN;                    /*              */
};                                                      /*              */
struct st_p8 {                                          /* struct P8    */
             unsigned char      DDR;                    /* P8DDR        */
             char               wk;                     /*              */
             union {                                    /* P8DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p9 {                                          /* struct P9    */
             unsigned char      DDR;                    /* P9DDR        */
             union {                                    /* P9DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_pa {                                          /* struct PA    */
             union {                                    /* PAODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             union {                                    /*              */
                   unsigned char DDR;                   /* PADDR        */
                   union {                              /* PAPIN        */
                         unsigned char BYTE;            /*  Byte Access */
                         struct {                       /*  Bit  Access */
                                unsigned char B7:1;     /*    Bit 7     */
                                unsigned char B6:1;     /*    Bit 6     */
                                unsigned char B5:1;     /*    Bit 5     */
                                unsigned char B4:1;     /*    Bit 4     */
                                unsigned char B3:1;     /*    Bit 3     */
                                unsigned char B2:1;     /*    Bit 2     */
                                unsigned char B1:1;     /*    Bit 1     */
                                unsigned char B0:1;     /*    Bit 0     */
                                }      BIT;             /*              */
                         }       PIN;                   /*              */
                   }            EQU;                    /*              */
};                                                      /*              */
struct st_pb {                                          /* struct PB    */
             union {                                    /* PBODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             union {                                    /* PBPIN        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PIN;                    /*              */
             unsigned char      DDR;                    /* PBDDR        */
};                                                      /*              */
struct st_bsc {                                         /* struct BSC   */
              union {                                   /* BCR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ICIS1 :1;      /*    ICIS1     */
                           unsigned char ICIS0 :1;      /*    ICIS0     */
                           unsigned char BRSTRM:1;      /*    BRSTRM    */
                           unsigned char BRSTS1:1;      /*    BRSTS1    */
                           unsigned char BRSTS0:1;      /*    BRSTS0    */
                           unsigned char       :1;      /*              */
                           unsigned char IOS   :2;      /*    IOS       */
                           }     BIT;                   /*              */
                    }           BCR;                    /*              */
              union {                                   /* WSCR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char RAMS:1;        /*    RAMS      */
                           unsigned char RAM0:1;        /*    RAM0      */
                           unsigned char ABW :1;        /*    ABW       */
                           unsigned char AST :1;        /*    AST       */
                           unsigned char WMS :2;        /*    WMS       */
                           unsigned char WC  :2;        /*    WC        */
                           }     BIT;                   /*              */
                    }           WSCR;                   /*              */
};                                                      /*              */
struct st_tmr {                                         /* struct TMR   */
              union {                                   /* TCR0         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMIEB:1;       /*    CMIEB     */
                           unsigned char CMIEA:1;       /*    CMIEA     */
                           unsigned char OVIE :1;       /*    OVIE      */
                           unsigned char CCLR :2;       /*    CCLR      */
                           unsigned char CKS  :3;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR0;                   /*              */
              union {                                   /* TCR1         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMIEB:1;       /*    CMIEB     */
                           unsigned char CMIEA:1;       /*    CMIEA     */
                           unsigned char OVIE :1;       /*    OVIE      */
                           unsigned char CCLR :2;       /*    CCLR      */
                           unsigned char CKS  :3;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR1;                   /*              */
              union {                                   /* TCSR0        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMFB:1;        /*    CMFB      */
                           unsigned char CMFA:1;        /*    CMFA      */
                           unsigned char OVF :1;        /*    OVF       */
                           unsigned char ADTE:1;        /*    ADTE      */
                           unsigned char OS  :4;        /*    OS        */
                           }      BIT;                  /*              */
                    }           TCSR0;                  /*              */
              union {                                   /* TCSR1        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMFB:1;        /*    CMFB      */
                           unsigned char CMFA:1;        /*    CMFA      */
                           unsigned char OVF :1;        /*    OVF       */
                           unsigned char     :1;        /*              */
                           unsigned char OS  :4;        /*    OS        */
                           }      BIT;                  /*              */
                    }           TCSR1;                  /*              */
              unsigned int      TCORA;                  /* TCORA        */
              unsigned int      TCORB;                  /* TCORB        */
              unsigned int      TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmr0 {                                        /* struct TMR0  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMIEB:1;      /*    CMIEB     */
                            unsigned char CMIEA:1;      /*    CMIEA     */
                            unsigned char OVIE :1;      /*    OVIE      */
                            unsigned char CCLR :2;      /*    CCLR      */
                            unsigned char CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               char             wk1;                    /*              */
               union {                                  /* TCSR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMFB:1;       /*    CMFB      */
                            unsigned char CMFA:1;       /*    CMFA      */
                            unsigned char OVF :1;       /*    OVF       */
                            unsigned char ADTE:1;       /*    ADTE      */
                            unsigned char OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               char             wk2;                    /*              */
               unsigned char    TCORA;                  /* TCORA        */
               char             wk3;                    /*              */
               unsigned char    TCORB;                  /* TCORB        */
               char             wk4;                    /*              */
               unsigned char    TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmr1 {                                        /* struct TMR1  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMIEB:1;      /*    CMIEB     */
                            unsigned char CMIEA:1;      /*    CMIEA     */
                            unsigned char OVIE :1;      /*    OVIE      */
                            unsigned char CCLR :2;      /*    CCLR      */
                            unsigned char CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               char             wk1;                    /*              */
               union {                                  /* TCSR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMFB:1;       /*    CMFB      */
                            unsigned char CMFA:1;       /*    CMFA      */
                            unsigned char OVF :1;       /*    OVF       */
                            unsigned char     :1;       /*              */
                            unsigned char OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               char             wk2;                    /*              */
               unsigned char    TCORA;                  /* TCORA        */
               char             wk3;                    /*              */
               unsigned char    TCORB;                  /* TCORB        */
               char             wk4;                    /*              */
               unsigned char    TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmry {                                        /* struct TMRY  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMIEB:1;      /*    CMIEB     */
                            unsigned char CMIEA:1;      /*    CMIEA     */
                            unsigned char OVIE :1;      /*    OVIE      */
                            unsigned char CCLR :2;      /*    CCLR      */
                            unsigned char CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TCSR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CMFB:1;       /*    CMFB      */
                            unsigned char CMFA:1;       /*    CMFA      */
                            unsigned char OVF :1;       /*    OVF       */
                            unsigned char ICIE:1;       /*    ICIE      */
                            unsigned char OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               unsigned char    TCORA;                  /* TCORA        */
               unsigned char    TCORB;                  /* TCORB        */
               unsigned char    TCNT;                   /* TCNT         */
               union {                                  /* TISR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char   :7;         /*              */
                            unsigned char IS:1;         /*    IS        */
                            }      BIT;                 /*              */
                     }          TISR;                   /*              */
};                                                      /*              */
struct st_ad {                                          /* struct A/D   */
             unsigned int       ADDRA;                  /* ADDRA        */
             unsigned int       ADDRB;                  /* ADDRB        */
             unsigned int       ADDRC;                  /* ADDRC        */
             unsigned int       ADDRD;                  /* ADDRD        */
             union {                                    /* ADCSR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char ADF :1;         /*    ADF       */
                          unsigned char ADIE:1;         /*    ADIE      */
                          unsigned char ADST:1;         /*    ADST      */
                          unsigned char SCAN:1;         /*    SCAN      */
                          unsigned char CKS :1;         /*    CKS       */
                          unsigned char CH  :3;         /*    CH        */
                          }      BIT;                   /*              */
                   }            ADCSR;                  /*              */
             union {                                    /* ADCR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char TRGS:2;         /*    TRGS      */
                          }      BIT;                   /*              */
                   }            ADCR;                   /*              */
};                                                      /*              */
struct st_da {                                          /* struct D/A   */
             unsigned char      DADR0;                  /* DADR0        */
             unsigned char      DADR1;                  /* DADR1        */
             union {                                    /* DACR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char DAOE1:1;        /*    DAOE1     */
                          unsigned char DAOE0:1;        /*    DAOE0     */
                          unsigned char DAE  :1;        /*    DAE       */
                          }      BIT;                   /*              */
                   }            DACR;                   /*              */
};                                                      /*              */
#define KBCOMP  (*(volatile union  un_kbcomp*)0xFFFEE4) /* KBCOMPAddress*/
#define INTC    (*(volatile struct st_intc  *)0xFFFEE8) /* INTC  Address*/
#define FLASH   (*(volatile struct st_flash *)0xFFFF80) /* FLASH Address*/
#define SBYCR   (*(volatile union  un_sbycr *)0xFFFF84) /* SBYCR Address*/
#define LPWRCR  (*(volatile union  un_lpwrcr*)0xFFFF85) /* LPWRCRAddress*/
#define MSTPCR  (*(volatile union  un_mstpcr*)0xFFFF86) /* MSTPCRAddress*/
#define STCR    (*(volatile union  un_stcr  *)0xFFFFC3) /* STCR  Address*/
#define SYSCR   (*(volatile union  un_syscr *)0xFFFFC4) /* SYSCR Address*/
#define MDCR    (*(volatile union  un_mdcr  *)0xFFFFC5) /* MDCR  Address*/
#define SCI0    (*(volatile struct st_sci   *)0xFFFFD8) /* SCI0  Address*/
#define SCI1    (*(volatile struct st_sci   *)0xFFFF88) /* SCI1  Address*/
#define SCI2    (*(volatile struct st_sci   *)0xFFFFA0) /* SCI2  Address*/
#define FRT     (*(volatile struct st_frt   *)0xFFFF90) /* FRT   Address*/
#define OCRB    OCRA                                    /* OCRB  Change */
#define OCRAR   ICRA                                    /* OCRAR Change */
#define OCRAF   ICRB                                    /* OCRAF Change */
#define OCRDM   ICRC                                    /* OCRDM Change */
#define PWMX    (*(volatile union  un_pwmx  *)0xFFFFA0) /* PWMX  Address*/
#define _DACR   REGS1.ST_DACR                           /* DACR  Change */
#define DACNT   REGS1.ST_DACNT                          /* DACNT Change */
#define DADRA   REGS0.ST_DADRA                          /* DADRA Change */
#define DADRB   REGS0.ST_DADRB                          /* DADRB Change */
#define WDT0    (*(volatile union  un_wdt0  *)0xFFFFA8) /* WDT0  Address*/
#define WDT1    (*(volatile union  un_wdt1  *)0xFFFFEA) /* WDT1  Address*/
#define P1      (*(volatile struct st_p1    *)0xFFFFAC) /* P1    Address*/
#define P2      (*(volatile struct st_p2    *)0xFFFFAD) /* P2    Address*/
#define P3      (*(volatile struct st_p3    *)0xFFFFAE) /* P3    Address*/
#define P4      (*(volatile struct st_p4    *)0xFFFFB5) /* P4    Address*/
#define P5      (*(volatile struct st_p5    *)0xFFFFB8) /* P5    Address*/
#define P6      (*(volatile struct st_p6    *)0xFFFFB9) /* P6    Address*/
#define P7      (*(volatile struct st_p7    *)0xFFFFBE) /* P7    Address*/
#define P8      (*(volatile struct st_p8    *)0xFFFFBD) /* P8    Address*/
#define P9      (*(volatile struct st_p9    *)0xFFFFC0) /* P9    Address*/
#define PA      (*(volatile struct st_pa    *)0xFFFFAA) /* PA    Address*/
#define PB      (*(volatile struct st_pb    *)0xFFFFBC) /* PB    Address*/
#define BSC     (*(volatile struct st_bsc   *)0xFFFFC6) /* BSC   Address*/
#define TMR     (*(volatile struct st_tmr   *)0xFFFFC8) /* TMR   Address*/
#define TMR0    (*(volatile struct st_tmr0  *)0xFFFFC8) /* TMR0  Address*/
#define TMR1    (*(volatile struct st_tmr1  *)0xFFFFC9) /* TMR1  Address*/
#define TMRY    (*(volatile struct st_tmry  *)0xFFFFF0) /* TMRY  Address*/
#define AD      (*(volatile struct st_ad    *)0xFFFFE0) /* A/D   Address*/
#define DA      (*(volatile struct st_da    *)0xFFFFF8) /* D/A   Address*/
